macroScript RenderHiddenWire category:"Render Tools" tooltip:"Hidden Wireframe Rendering" 
(

--RENDER HIDDEN WIREFRAME
--Version 1.0 - 6/12/99
--Started: 6/12/99
--Edited:  6/12/99
--by Borislav Petrov
--bobo@email.archlab.tuwien.ac.at
--http://gfxcentral.com/bobo/
---------------------------------------


global wire_nf

rollout wire_roll "HiddenWireframe"
(
spinner wire_thickness "Thickness:" range:[0,100,1] type:#float align:#right wieldwidth:40
radiobuttons wire_mode labels:#("Wire+Solid Color","Wire+Background","User+Background")
colorpicker custom_wire "User Wire:" color:(color 255 255 255) fieldwidth:35 height:15 align:#right
colorpicker custom_color "Background:" color:backgroundcolor fieldwidth:35 height:15 align:#right
checkbutton render_frame "Render HiddenWire" width:106 height:30 align:#center highlightcolor:(color 255 200 200) tooltip:"Render a Frame with HiddenWireframe"

fn render_wire =
(
bmp1 = render forceWireframe:false channels:#(#node,#coverage) vfb:false
bmp2 = render forceWireframe:true force2sided:false channels:#(#node,#coverage) vfb:false wirethickness:wire_thickness.value


out_bmp = bitmap bmp1.width bmp1.height
out_bmp .filename = "Hidden Wireframe Rendering"	
display out_bmp 


for v = 0 to bmp1.height-1 do
(
pixel1_line = getpixels bmp1 [0,v] bmp1.width
pixel2_line = getpixels bmp2 [0,v] bmp2.width

new_line = #()
for h = 1 to bmp1.width do
	(
	node1 = getchannel bmp1 [h-1,v] #node
	node2 = getchannel bmp2 [h-1,v] #node
	cover1 = getchannel bmp1 [h-1,v] #coverage
	cover2 = getchannel bmp2 [h-1,v] #coverage

case wire_mode.state of
(
1: (
	if node1[1] == node2[1] then 
		(
		if node1[1] != undefined then
			(
			new_line[h] = (node1[1].wirecolor * (cover2[1]/255.0)) + (pixel1_line[h] * (1-(cover2[1]/255.0)))
			)
			else
			(
			new_line[h] = pixel1_line[h]
			)
		)
		else 
		(
		new_line[h] = pixel1_line[h]
		)
	)

2: (
if node1[1] == node2[1] then 
		(
		if node1[1] != undefined then
			(
			new_line[h] = (node1[1].wirecolor * (cover2[1]/255.0)) + (custom_color.color * (1-(cover2[1]/255.0)))
			)
			else
			(
			new_line[h] = custom_color.color
			)
		)
		else 
		(
		new_line[h] = custom_color.color
		)

	)
3: (
if node1[1] == node2[1] then 
		(
		if node1[1] != undefined then
			(
			new_line[h] = (custom_wire.color * (cover2[1]/255.0)) + (custom_color.color * (1-(cover2[1]/255.0)))
			)
			else
			(
			new_line[h] = custom_color.color
			)
		)
		else 
		(
		new_line[h] = custom_color.color
		)

	)	
)--end case
new_line[h].alpha = pixel1_line[h].alpha
)--end h loop

setpixels out_bmp [0,v] new_line	
if (v / 10.0) == floor(v/10.0) then display out_bmp 
)
close bmp1
close bmp2
gc()
display out_bmp 
)--end fn

on render_frame changed state do 
	(
	render_frame.enabled = false
	if state then render_wire()
	render_frame.checked = false
	render_frame.enabled = true
	)

)--end rollout

if wire_nf != undefined then closerolloutfloater wire_nf
wire_nf = newrolloutfloater "HW v1.0" 150 210 100 100
addrollout wire_roll wire_nf 


)--end script

